using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace takmicenje
{
    class Program
    {
        struct grupa
        {
            public string gr;
            public int br;
        }
        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());
            string[] r = Console.ReadLine().Split();
            int[] a = new int[4];
            int[] b = new int[4];
            a[0] = int.Parse(r[0]);
            a[1] = int.Parse(r[1]);
            a[2] = int.Parse(r[2]);
            a[3] = int.Parse(r[3]);
            grupa[] st = new grupa[n];
            string[] grupe = { "O", "A", "B", "AB" };
            int[,] g = new int[n, 4];
            int br = 0;
            for (int i = 0; i < n; i++)
            {
                string[] str = Console.ReadLine().Split();
                st[i].gr = str[0];
                st[i].br = int.Parse(str[1]);
            }

            for (int i = 0; i < n; i++)
            {
                if (st[i].gr == grupe[0])
                {
                    while (st[i].br > 0 && a[0] > 0)
                    {
                        a[0]--;
                        a[0]++;
                        st[i].br--;
                    }
                    if (st[i].br > 0)
                        br++;
                }
                else if (st[i].gr == grupe[1])
                {
                    while (st[i].br > 0 && (a[1] > 0 || a[0] > 0))
                    {
                        if (a[1] > 0)
                        {
                            a[1]--;
                            b[1]++;
                        }
                        else if (a[0] > 0)
                        {
                            a[0]--;
                            b[0]++;
                        }
                        st[i].br--;
                    }
                    if (st[i].br > 0)
                        br++;
                }
                else if (st[i].gr == grupe[2])
                {
                    while (st[i].br > 0 && (a[2] > 0 || a[0] > 0))
                    {
                        if (a[2] > 0)
                        {
                            a[2]--;
                            b[2]++;
                        }
                        else if (a[0] > 0)
                        {
                            a[0]--;
                            b[0]++;
                        }

                        st[i].br--;
                    }
                    if (st[i].br > 0) br++;
                }
                g[i, 0] = b[0];
                b[0] = 0;
                g[i, 1] = b[1];
                b[1] = 0;
                g[i, 2] = b[2];
                b[2] = 0;
                g[i, 3] = b[3];
            }

            for (int i = 0; i < n; i++)
                if (st[i].gr == grupe[3])
                {
                    while (st[i].br > 0 && (a[2] > 0 || a[1] > 0))
                    {
                        if (a[3] > 0)
                        {
                            a[3]--;
                            b[3]++;
                        }
                        else if (a[1] > 0)
                        {
                            a[1]--;
                            b[1]++;
                        }
                        else if (a[2] > 0)
                        {
                            a[2]--;
                            b[2]++;
                        }
                        else if (a[0] > 0)
                        {
                            a[0]--;
                            b[0]++;
                        }

                        st[i].br--;
                    }
                    g[i, 0] = b[0];
                    g[i, 1] = b[1];
                    g[i, 2] = b[2];
                    g[i, 3] = b[3];
                    if (st[i].br > 0)br++;
                }
            if (br > 0)
                Console.WriteLine("nemoguce");
            else
            {
                Console.WriteLine("moguce");
                for (int i = 0; i < n; i++)
                {
                    for (int j = 0; j < 4; j++)
                        Console.Write(g[i, j] + " ");
                    Console.WriteLine();
                }
            }
        }
    }
}